<?php
/* 
 * $Id: functions-inc.php,v 1.5 2005/01/09 12:56:42 veghead Exp $
 */


function getFilename($rawLine,$mode) 
{
	//print(":$rawLine:<br>\n");
	/* Remove everything but the filename (hopefully) */
	$namemask="/^..........\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s/";
	$pa=preg_replace($namemask,"",$rawLine);

	/* do we want the real filename if it's a symlink ? */
	if (getFileType($rawLine)=='l') {

		if ($mode==1) {
			$pa = preg_replace('/ \->.*/','',$pa);
		} elseif ($mode==2) {
			$pa = preg_replace('/^.* -> /','',$pa);
		}
	}
	return $pa;
}


function getOwner($rawLine) 
{
	$owner=preg_replace("/^\S+\s+\S+\s+(\S+)\s.*/","$1",$rawLine);
	return $owner;
}


function getMIMEType($rawLine) 
{
	global $mime_extension_map;
	if (! empty($mime_extension_map[getFileExt($rawLine)])) {
		return($mime_extension_map[getFileExt($rawLine)]) ;
	}
	return("");
}

function FileTam($rawLine) {
	global $conf;

	$pa = $rawLine;
	if ($pa < 0) {
		return $conf['nls']['folder'];
	} else {
		if ($pa > 1000) {
			$ntam = ceil($pa/1024);
			if ($ntam > 1000) {
				$ntam = ceil($ntam/1024)." mb";
			} else {
				$ntam = $ntam." kb";
			}
		} else {
			$ntam = $pa." bytes";
		}
		return $ntam;
	}
}


function getFileDate($rawLine) {
	global $conn_id;
	global $conf;
	$lm_unix = ftp_mdtm($conn_id,getFilename($rawLine,0));
	$pa = strftime ($conf['nls']['date_format'] ,$lm_unix);
	return $pa;
}



function getFileExt($rawLine) {
	if (strlen($rawLine)<55) { return(""); }
	$pa = substr($rawLine,55,strlen($rawLine)-55);
	$p = strrpos($pa,".");
	$ext = substr($pa,$p+1,strlen($pa)-$p);
	return $ext;
}


function getFileMode($rawLine) 
{
	return(substr($rawLine,1,9));
}


function getFileType($rawLine) 
{
	return(substr($rawLine,0,1));
}



function getFileTypeIcon($rawLine) 
{
	global $tp,$conf;
	
	$ext = getFileExt($rawLine);
	
	$img = "";
	if ((getFileType($rawLine)=="d")||(getFileType($rawLine) == "l")) {
		return("<img src=\"".$conf['imgdir']."/dir.gif\" alt=\"\">");
	} 

	for ($i = 0; $i <= count($tp); $i++) {
		if (empty($tp)) { continue; }
		if (! empty($tp[$i])) {
			$tmp = explode(",",$tp[$i]);
		} else {
			$tmp = array();
		}
		
		for ($ii = 0; $ii <= count($tmp); $ii++) {
			if ((!empty($tmp[$ii])) && 
					(preg_match("/".$tmp[$ii]."/i",$ext))) {
				$img = "<img src=\"".$conf['imgdir']."/$tmp[0]\" width=\"20\" height=\"22\" border=\"0\" alt=\"\">";
			}
		}
	}

	// Unknown
	if ((!$ext) || empty($img)) {
		$img = "<img src=\"".$conf['imgdir']."/unknown.gif\" width=\"20\" height=\"22\" border=\"0\" alt=\"\">";
	}
	return $img;
}


function showHeader() 
{
	global $Font_format_menu;
	global $Font_format_title;
	global $sessionID;
	global $pwd;
	global $PHP_SELF;
	global $conf;
	include("header-inc.php");
}


function showFooter() 
{
	include("footer-inc.php");
}



function loginPage($errbanner="")
{
	global $PHP_SELF;
	global $conf;
	showHeader();
	include("loginform-inc.php");
	showFooter();
}

?>
